package com.restlet.client.dao;

import com.restlet.client.async.Promise;
import com.restlet.client.model.ImportPolicy;
import com.restlet.client.model.environment.EnvironmentConfigTo;
import com.restlet.client.model.environment.EnvironmentTo;
import com.restlet.client.utils.Nullable;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface EnvironmentsDao {

    Promise<List<EnvironmentTo>> list();

    Promise<EnvironmentTo> findByName(String name);

    Promise<EnvironmentTo> read(String id);

    Promise<EnvironmentTo> readSelected();

    Promise<EnvironmentTo> persist(EnvironmentTo dto);

    Promise<Void> delete(EnvironmentTo dto);

    @Deprecated
    Promise<EnvironmentConfigTo> readConfig();

    @Deprecated
    Promise<Void> patchSelected(String name);

    Promise<List<EnvironmentTo>> importEnvironments(ImportPolicy importPolicy, Map<String, EnvironmentTo> environments, @Nullable Set<String> importOnly);

    Promise<Integer> count();
}
