package com.restlet.client.dao;

import com.restlet.client.async.Promise;
import com.restlet.client.model.EntityTo;
import com.restlet.client.model.EntityTreeNode;

import java.util.List;

public interface RepositoryDao {
    String SHARED_DB_PREFIX = "shared_";

    /**
     * @deprecated Use synchronous method instead
     */
    @Deprecated
    Promise<EntityTo> read(String id);

    EntityTo readSync(String id);

    /**
     * @deprecated Use synchronous method instead
     */
    @Deprecated
    Promise<EntityTreeNode> readEntityTree(String entityId);

    EntityTreeNode readEntityTreeSync(String entityId);

    EntityTreeNode readEntityTreeWithParentsSync(String entityId);

    /**
     * @deprecated Use synchronous method instead
     */
    @Deprecated
    Promise<EntityTo> find(String name, EntityTo parent);

    EntityTo findSync(String name, String parentId);

    /**
     * @deprecated Use synchronous method instead
     */
    @Deprecated
    Promise<List<EntityTo>> filter(EntityTo.Type type, EntityTo parent);

    List<EntityTo> filterSync(EntityTo.Type type, EntityTo parent);

    List<EntityTo> filterSync(EntityTo.Type type, String parentId);

    List<EntityTo> getChildrenSync(String parentId);
}
