package com.restlet.client.model;

import com.restlet.client.platform.UUIDGenerator;

import static com.restlet.client.utils.StringUtils.format;

public enum ImportIdPolicy {

    CREATE_NEW_IDS {
        @Override
        public EntityTo setIdForCreation(final EntityTo entity) {
            entity.setId(UUIDGenerator.uuid());
            return entity;
        }
    },
    KEEP_IMPORTED_IDS {
        @Override
        public EntityTo setIdForCreation(final EntityTo entity) {
            if (entity.getId() == null) {
                throw new IllegalArgumentException(format("Entity %s should have an id.", entity.getName()));
            }

            return entity;
        }
    };

    public abstract EntityTo setIdForCreation(EntityTo entity);
}
