package com.restlet.client.net.http.request;

import com.restlet.client.net.http.HttpExampleTo;
import com.restlet.client.net.request.RequestBodyTo;
import com.restlet.client.net.request.RequestHeaderTo;
import com.restlet.client.net.request.RequestHeadersType;
import com.restlet.client.net.request.RequestTo;
import com.restlet.client.tests.Testable;

import java.util.List;
import java.util.Map;

public interface HttpRequestTo extends RequestTo, Testable {

    HttpMethodDefinition getMethod();

    void setMethod(HttpMethodDefinition method);

    List<RequestHeaderTo> getHeaders();

    void setHeaders(List<RequestHeaderTo> headers);

    RequestHeadersType getHeadersType();

    void setHeadersType(RequestHeadersType type);

    // indicates if the query editor is open (true) or collapsed (false)
    boolean getUriEditor();

    // indicates if the query editor is open (true) or collapsed (false)
    void setUriEditor(boolean visible);

    RequestBodyTo getBody();

    void setBody(RequestBodyTo body);

    boolean containsNoErrors();

    List<HttpExampleTo> getExamples();

    void setExamples(List<HttpExampleTo> examples);

    Map<String, String> getMetaInfo();

    void setMetaInfo(Map<String, String> meta);

    boolean isBodyEvaluationDisabled();

    void setBodyEvaluationDisabled(boolean value);

}
