package com.restlet.client.platform.json;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class JsonArrayImpl implements JsonArray {

    private final List<Object> array;
    private final JsonEngine jsonEngine;

    public JsonArrayImpl(final Collection<Object> array, final JsonEngine jsonEngine) {
        this.array = new ArrayList<>(array);
        this.jsonEngine = jsonEngine;
    }

    @Override
    public JsonObject isObject() {
        return null;
    }

    @Override
    public JsonArray isArray() {
        return this;
    }

    @Override
    public JsonNull isNull() {
        return null;
    }

    @Override
    public JsonString isString() {
        return null;
    }

    @Override
    public JsonBoolean isBoolean() {
        return null;
    }

    @Override
    public JsonNumber isNumber() {
        return null;
    }

    @Override
    public Integer size() {
        return array.size();
    }

    @Override
    public JsonValue get(final Integer index) {
        return JsonObjectImpl.wrap(array.get(index), this.jsonEngine);
    }

    public Collection<Object> collection() {
        return array;
    }

    @Override
    public void set(final Integer index, final JsonValue value) {
        while (array.size() <= index) {
            array.add(null);
        }
        array.set(index, JsonObjectImpl.unwrap(value));
    }

    @Override
    public String toString() {
        return jsonEngine.toJson(this);
    }
}
