package com.restlet.client.script.method;

import com.restlet.client.async.Promise;
import com.restlet.client.async.Promises;
import com.restlet.client.platform.CryptoApi;
import com.restlet.client.platform.json.JsonEngine;
import com.restlet.client.script.runtime.ScriptMethod;
import com.restlet.client.script.runtime.ScriptValue;
import com.restlet.client.script.value.ScriptStringValue;

import java.util.List;

public class MD5Method implements ScriptMethod {

    private final CryptoApi cryptoApi;
    final JsonEngine jsonEngine;

    public MD5Method(CryptoApi cryptoApi, JsonEngine jsonEngine) {
        this.cryptoApi = cryptoApi;
        this.jsonEngine = jsonEngine;
    }

    @Override
    public String getName() {
        return "md5";
    }

    @Override
    public Promise<ScriptValue> execute(ScriptValue value, List<ScriptValue> args) {
        if (value == null) {
            return Promises.of();
        }

        return Promises.when(new ScriptStringValue(cryptoApi.md5(value.toString()), jsonEngine));
    }

}
