package com.restlet.client.script.runtime.impl;

import com.restlet.client.async.Promise;
import com.restlet.client.dao.EnvironmentsDao;
import com.restlet.client.dao.RepositoryDao;
import com.restlet.client.model.EntityTo;
import com.restlet.client.script.RepositoryReader;
import com.restlet.client.script.runtime.ScriptValue;

public class RepositoryRecordReference implements ScriptValue {

    private final RepositoryReader repositoryReader;
    private final EntityTo entity;
    private final EnvironmentsDao environmentsDao;
    private final RepositoryDao repositoryDao;

    public RepositoryRecordReference(final RepositoryReader exprSvc, final EntityTo entity, final EnvironmentsDao environmentsDao, final RepositoryDao repositoryDao) {
        this.repositoryReader = exprSvc;
        this.entity = entity;
        this.environmentsDao = environmentsDao;
        this.repositoryDao = repositoryDao;
    }

    @Override
    public String toString() {
        return "{\"name\":\"" + entity.getName() + "\",\"type\":\"" + entity.getType() + "\"}";
    }

    @Override
    public Promise<ScriptValue> select(final String path) {
        return repositoryReader.readFromRepo(path, entity, repositoryDao, environmentsDao);
    }
}
