package com.restlet.client.script.runtime.impl;

import com.restlet.client.platform.json.JsonEngine;
import com.restlet.client.platform.json.JsonObject;
import com.restlet.client.platform.json.JsonValue;

public class RequestContainerJsonReference {

    private final JsonObject root;
    private final JsonEngine jsonEngine;

    public RequestContainerJsonReference(final JsonObject root, final JsonEngine jsonEngine) {
        this.root = root;
        this.jsonEngine = jsonEngine;
    }

    public void setName(final String name) {
        root.put("name", jsonEngine.newJsonString(name));
    }

    public void setRequest(final RequestJSONReference request) {
        root.put("request", (request == null) ? null : request.asJSON());
    }

    public void setResponse(final ResponseJSONReference response) {
        root.put("response", (response == null) ? null : response.asJSON());
    }

    public JsonValue asJSON() {
        return root;
    }

}
