package com.restlet.client.script.scanner.lex;

public final class SimpleLexeme implements ScriptLexeme {

    final ScriptLexType type;
    final String value;

    final int index;

    public SimpleLexeme(ScriptLexType type, int index) {
        this(type, index, null);
    }

    public SimpleLexeme(ScriptLexType type, int index, String value) {
        this.type = type;
        this.index = index;
        this.value = value;
    }

    @Override
    public ScriptLexType getType() {
        return type;
    }

    public String getValue() {
        return value;
    }

    @Override
    public int getIndex() {
        return index;
    }

    @Override
    public String toString() {
        return this.getClass().getSimpleName() + "[type: " + type + ", value: '" + value + "', index: '" + index + "']";
    }
}
