package com.restlet.client.script.scanner.lex;


public final class StringLexeme implements ScriptLexeme {

    final String value;
    final Character quote;
    final int index;

    public StringLexeme(String value, int index) {
        this(value, index, null);
    }

    public StringLexeme(String value, int index, Character quote) {
        this.value = value;
        this.index = index;
        this.quote = quote;
    }

    public String getValue() {
        return value;
    }

    public Character getQuote() {
        return quote;
    }

    @Override
    public ScriptLexType getType() {
        return ScriptLexType.QuotedString;
    }

    @Override
    public int getIndex() {
        return index;
    }

    @Override
    public String toString() {
        return this.getClass().getSimpleName() + "[type: " + getType() + ", value: '" + value + "', index: '" + index + "']";
    }
}
