package com.restlet.client.tests;

import com.restlet.client.net.http.request.HttpRequestTo;
import com.restlet.client.net.http.request.impl.EffectiveHttpRequestTo;
import com.restlet.client.tests.impl.ExecutionStateStore;
import com.restlet.client.utils.Maybe;

import java.util.List;

public interface SingleRequestTestResult extends TestResult<SingleRequestTestResult, HttpRequestTo> {

    String getMessage();

    SingleRequestTestResult setMessage(String message);

    // don't be fooled by Intellij, this method is used by JunitReportWriter
    EffectiveHttpRequestTo getEffectiveRequest();

    SingleRequestTestResult setEffectiveRequest(EffectiveHttpRequestTo effectiveHttpRequestTo);

    List<SingleRequestTryTestResult> getTriesResults();

    SingleRequestTestResult addTryResult(SingleRequestTryTestResult tryResult);

    boolean isDynamicRequest();

    boolean isEnded();

    SingleRequestTestResult setDynamicRequest(boolean dynamicRequest);

    boolean isLocalRequest();

    SingleRequestTestResult setLocalRequest(boolean localRequest);

    /**
     * @param fireEvent True to notify listeners that the parent's state has been updated, false otherwise.
     */
    SingleRequestTestResult refreshParentState(final ExecutionStateStore.RunType runType, boolean fireEvent);

    Maybe<SingleRequestTryTestResult> getLastNonSkippedTry();

    boolean isRetryEnabled();

    int getCurrentTryBaseOneRetryIndex();

    SingleRequestTestResult setCurrentTryBaseOneRetryIndex(int currentTryBaseOneIndex);

    boolean isRequestInvalid();

    SingleRequestTestResult setRequestInvalid(boolean isRequestInvalid);

}
