package com.restlet.client.utils;

import com.restlet.client.function.Function;
import com.restlet.client.tests.asserts.AssertionResultTo;
import com.restlet.client.tests.asserts.AssertionTo;

import java.util.List;

public class AssertionUtils {

    public static Sequence<AssertionTo> mapToAssertions(final List<AssertionResultTo> assertionResults) {
        return Sequence.of(assertionResults)
                .omitNulls()
                .map(new Function<AssertionResultTo, AssertionTo>() {
                    @Override
                    public AssertionTo apply(final AssertionResultTo assertionResultTo) {
                        return assertionResultTo.getAssertion();
                    }
                });
    }

    public static Sequence<AssertionResultTo> mapToAssertionResultTos(final List<AssertionTo> assertions) {
        return Sequence.of(assertions)
                .omitNulls()
                .map(new Function<AssertionTo, AssertionResultTo>() {
                    @Override
                    public AssertionResultTo apply(final AssertionTo assertion) {
                        return new AssertionResultTo(assertion);
                    }
                });
    }
}
