package com.restlet.client.utils;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import static java.util.Arrays.asList;

public class SetBuilder<T> {

    private final Set<T> local = new HashSet<>();

    private SetBuilder() {
    }

    public static <T> SetBuilder<T> builder() {
        return new SetBuilder<>();
    }

    public SetBuilder<T> add(T value) {
        local.add(value);
        return this;
    }

    public SetBuilder<T> addAll(Collection<? extends T> list) {
        local.addAll(list);
        return this;
    }

    public SetBuilder<T> addAll(T[] additionalFields) {
        return addAll(asList(additionalFields));
    }

    public Set<T> build() {
        return local;
    }

}
